Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Definition plus_O_n : forall (n:nat), logic.eq (nat) n (plus O n) := fun (n:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((logic.refl) (nat)) (n)))).
